SystemOrganization addCategory: #'Pier-Paypal-Model'!
SystemOrganization addCategory: #'Pier-Paypal-Magritte'!
SystemOrganization addCategory: #'Pier-Paypal-Seaside'!

MAComponentDecoration subclass: #MAPaypalCartDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Magritte'!

!PRVisitor methodsFor: '*pier-paypal-model' stamp: 'jmck 3/14/2009 21:15'!
visitPaypalStore: aStore
	self visitCase: aStore! !

!PRVisitor methodsFor: '*pier-paypal-model' stamp: 'jmck 3/15/2009 02:28'!
visitPaypalStoreItem: aStoreItem
	self visitCase: aStoreItem! !

PRCase subclass: #PRPaypalCart
	instanceVariableNames: 'store cartItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Model'!

!PRPaypalCart class methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 02:23'!
accept: aVisitor
	aVisitor visitPaypalStore: self! !

!PRPaypalCart class methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 02:23'!
canBeParentOf: aClass
	^ aClass includesBehavior: PRPaypalStoreItem! !

!PRPaypalCart methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 23:50'!
cartItems
	^cartItems ifNil: [ 
		cartItems := store items collect: [ :item | 
			PRPaypalCartItem forItem: item ] ]! !

PRCase subclass: #PRPaypalStore
	instanceVariableNames: 'bn business PAL MRB note currencyCode shipping notifyUrl hdr hdrColor logo'
	classVariableNames: 'Items'
	poolDictionaries: ''
	category: 'Pier-Paypal-Model'!

!PRPaypalStore class methodsFor: 'visiting' stamp: 'jmck 3/14/2009 21:13'!
accept: aVisitor
	aVisitor visitPaypalStore: self! !

!PRPaypalStore class methodsFor: 'testing' stamp: 'jmck 3/14/2009 23:48'!
canBeParentOf: aClass
	^ aClass includesBehavior: PRPaypalStoreItem! !

!PRPaypalStore class methodsFor: 'defaults' stamp: 'jmck 3/15/2009 00:04'!
defaultBN
	^'pier.seaside.smalltalk'! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 01:58'!
descriptionBackgroundColor
	^MAColorDescription new
		propertyAccessor: 'cpp_ headerback_ color';
		label: 'Background Color';
		comment: 'Background color for logo that PayPal will display';
		group: 'Paypal Settings';
		priority: 144;
		beSetting;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 01:20'!
descriptionBn
	^MAStringDescription new
		propertyAccessor: 'bn';
		label: 'Store Builder Name';
		comment: '"Builder Name" for this store';
		group: 'Paypal Settings';
		default: self defaultBN;
		priority: 111;
		beSetting;
		beOptional;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 01:14'!
descriptionBusiness
	^MAStringDescription new
		propertyAccessor: 'business';
		label: 'Business';
		comment: '"Buisness ID for this store (account email address)';
		priority: 110;
		group: 'Paypal Settings';
		beSetting;
		beRequired;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 01:28'!
descriptionCurrencyCode
	^MASingleOptionDescription new
		options: #('USD' 'EUR' 'YEN' 'LYRA');
		propertyAccessor: 'currency_code';
		label: 'Currency code';
		comment: 'Currency code';
		group: 'Paypal Settings';
		priority: 112;
		beSetting;
		beRequired;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 01:32'!
descriptionHeaderBorderColor
	^MAColorDescription new
		propertyAccessor: 'cpp_ headerborder_color';
		label: 'Header Border Color';
		comment: 'Header border color for logo that PayPal will display';
		group: 'Paypal Settings';
		priority: 142;
		beSetting;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 01:32'!
descriptionHeaderImage
	^MAFileDescription new
		propertyAccessor: 'cpp_header_ image';
		label: 'Header Image';
		comment: 'URL for logo image that PayPal will display';
		group: 'Paypal Settings';
		priority: 141;
		beSetting;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/14/2009 23:48'!
descriptionItems
	^MAToManyRelationDescription new
		classes: PRPaypalStoreItem;
		accessor: #items;
		label: 'Store Items';
		priority: 110;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 01:32'!
descriptionLogoImage
	^MAFileDescription new
		propertyAccessor: 'image_url';
		label: 'Logo Image';
		comment: 'URL for logo image that PayPal will display';
		group: 'Paypal Settings';
		priority: 140;
		beSetting;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 01:31'!
descriptionMRB
	^MAStringDescription new
		propertyAccessor: 'mrb';
		label: 'Merchant Referral Bonus ID';
		comment: 'MRB ID issued by PayPal';
		group: 'Paypal Settings';
		priority: 131;
		beSetting;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 01:30'!
descriptionNote
	^MASingleOptionDescription new
		optionsAndLabels: {'0'->'Show note text box'. '1'->'Hide note textbox'.};
		propertyAccessor: 'no_note';
		label: 'Show/Hide Note textbox';
		comment: 'Whether or not to allow buyer to enter a note';
		group: 'Paypal Settings';
		priority: 121;
		beSetting;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 01:31'!
descriptionNotifyUrl
	^MAStringDescription new
		propertyAccessor: 'notify_url';
		label: 'Notify URL';
		comment: 'The URL to which PayPal posts information about the transaction';
		group: 'Paypal Settings';
		priority: 132;
		beSetting;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 01:31'!
descriptionPAL
	^MAStringDescription new
		propertyAccessor: 'pal';
		label: 'Paypal ID';
		comment: 'Pal ID issued by PayPal';
		group: 'Paypal Settings';
		priority: 130;
		beSetting;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 01:33'!
descriptionPayflowColor
	^MAColorDescription new
		propertyAccessor: 'cpp_payflow_ color';
		label: 'Payflow color';
		comment: 'Payflow color for logo that PayPal will display';
		group: 'Paypal Settings';
		priority: 143;
		beSetting;
		yourself! !

!PRPaypalStore class methodsFor: 'described' stamp: 'jmck 3/15/2009 01:29'!
descriptionShipping
	^MASingleOptionDescription new
		optionsAndLabels: {'0'->'Prompt - Required'. '1'->'Do not prompt'. '2'->'Prompt - Required'};
		propertyAccessor: 'no_shipping';
		label: 'Shipping Address Option';
		comment: 'Whether or not to require shipping address Unmatched string quote ->';
		group: 'Paypal Settings';
		priority: 120;
		beSetting;
		beRequired;
		yourself! !

!PRPaypalStore class methodsFor: 'testing' stamp: 'jmck 3/14/2009 11:13'!
isAbstract
	^false! !

!PRPaypalStore methodsFor: 'visiting' stamp: 'jmck 3/14/2009 23:09'!
accept: aVisitor
	aVisitor visitPaypalStore: self! !

!PRPaypalStore methodsFor: 'accessing' stamp: 'jmck 3/15/2009 01:50'!
allStoreItemsIn: aContext
	"Answer all the comments in choronological order."

	^ ((aContext enumeratorFor: self) all
		select: [ :each |
			each isStoreItem ])
		sort: [ :a :b | (a propertyAt: 'item_number') < (b propertyAt: 'item_number') ];
		yourself! !

!PRPaypalStore methodsFor: 'testing' stamp: 'jmck 3/15/2009 02:10'!
canBeParentOf: aClass
	^ aClass includesBehavior: PRPaypalStoreItem! !

!PRPaypalStore methodsFor: 'testing' stamp: 'jmck 3/15/2009 01:50'!
isStoreItem
	^false! !

!PRPaypalStore methodsFor: 'testing' stamp: 'jmck 3/15/2009 01:47'!
isValidView: aComponentClass in: aContext
	^ super viewComponentClass ~= aComponentClass! !

!PRPaypalStore methodsFor: 'accessing' stamp: 'jmck 3/14/2009 13:23'!
items
	^Items ifNil: [ Items := OrderedCollection new ]! !

!PRPaypalStore methodsFor: 'accessing' stamp: 'jmck 3/14/2009 13:26'!
items: aCollection
	^Items := aCollection! !

!PRPaypalStore methodsFor: 'rendering' stamp: 'jmck 3/15/2009 01:34'!
viewComponentClass
	^ PRPaypalStoreView! !

PRCase subclass: #PRPaypalStoreItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Model'!

PRPaypalStoreItem subclass: #PRPaypalCartItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Model'!

!PRPaypalCartItem class methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 02:20'!
canBeChildOf: aClass
	^aClass includesBehavior: PRPaypalCart! !

!PRPaypalCartItem class methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 21:44'!
descriptionQuantity
	^MANumberDescription new
		propertyAccessor: 'quantity';
		label: 'Quantity';
		comment: 'Number of Items';
		viewComponentClass: MARangeComponent;
		priority: 100;
		bePositive;
		beEditable;
		yourself! !

!PRPaypalCartItem class methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 21:39'!
forItem: anItem
	| item |
	item := self new.
	anItem properties keysAndValuesDo: [ :property :value |
		item perform: (property asMutator: value) ].
	^ item
		! !

!PRPaypalStoreItem class methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 23:47'!
canBeChildOf: aClass
	^aClass includesBehavior: PRPaypalStore! !

!PRPaypalStoreItem class methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 23:46'!
canBeParentOf: aClass
	^false! !

!PRPaypalStoreItem class methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:42'!
descriptionAmount
	^MANumberDescription new
		propertyAccessor: #amount;
		label: 'Price';
		comment: 'Selling price for this item';
		group: 'Paypal Settings';
		priority: 130;
		beEditable;
		yourself! !

!PRPaypalStoreItem class methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:42'!
descriptionItemName
	^MAStringDescription new
		propertyAccessor: 'item_name';
		label: 'Description';
		comment: 'Description of item';
		group: 'Paypal Settings';
		priority: 120;
		beEditable;
		yourself! !

!PRPaypalStoreItem class methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:41'!
descriptionItemNumber
	^MAStringDescription new
		propertyAccessor: 'item_number';
		label: 'Item';
		comment: 'Pass-through variable for you to track product or service purchased';
		group: 'Paypal Settings';
		priority: 110;
		beEditable;
		yourself! !

!PRPaypalStoreItem class methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:42'!
descriptionWeight
	^MANumberDescription new
		propertyAccessor: 'weight';
		label: 'Weight';
		comment: 'Total weight for this line item';
		group: 'Paypal Settings';
		priority: 150;
		bePositive;
		beEditable;
		yourself! !

!PRPaypalStoreItem class methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:43'!
descriptionWeightUnit
	^MASingleOptionDescription new
		options: #( 'lbs' 'kgs');
		propertyAccessor: 'weight_unit';
		label: 'Weight Unit';
		comment: 'Units of measure for the weight for this line item';
		group: 'Paypal Settings';
		priority: 160;
		beEditable;
		yourself! !

!PRPaypalStoreItem class methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 02:17'!
isAbstract
	^false! !

!PRPaypalStoreItem methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:55'!
accept: aVisitor
	aVisitor visitPaypalStoreItem: self! !

!PRPaypalStoreItem methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 02:30'!
canBeChildOf: aClass
	^aClass includesBehavior: PRPaypalStore! !

!PRPaypalStoreItem methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 02:31'!
canBeParentOf: aClass
	^false! !

!PRPaypalStoreItem methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:51'!
isStoreItem
	^true! !

!PRPaypalStoreItem methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:35'!
viewComponentClass
	^ PRPaypalStoreItemView! !

PRDefaultView subclass: #PRPaypalStoreItemView
	instanceVariableNames: 'item component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Seaside'!

!PRPaypalStoreItemView methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:38'!
buildComponent
	^ self item asComponent
		addValidatedForm;
		onAnswer: [ :value | self answer: value ];
		yourself! !

!PRPaypalStoreItemView methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:37'!
component
	^ component ifNil: [ component := self buildComponent ]! !

!PRPaypalStoreItemView methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:39'!
item
	^ item ifNil: [ item := PRPaypalStoreItem new ]! !

!PRPaypalStoreItemView methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:40'!
renderViewerOn: html
	html render: self component! !

PRDefaultView subclass: #PRPaypalStoreView
	instanceVariableNames: 'store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Seaside'!

!PRPaypalStoreView methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 20:19'!
addItem! !

!PRPaypalStoreView methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 20:16'!
buildComponent
	^self store asComponent
		addValidatedForm;
		onAnswer: [ :value | self answer: value ];
		yourself! !

!PRPaypalStoreView methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 23:50'!
buildReport
	^ (MAReport rows: self store items description: PRPaypalStoreItem description)
		"addColumn: (MACommandColumn new
			addCommandOn: self selector: #addItem text: 'Add Item';
			addCommandOn: self selector: #editItem text: 'Edit Item';
			addCommandOn: self selector: removeItem text: 'Remove';
			yourself);
		yourself"
		! !

!PRPaypalStoreView methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 20:15'!
component
	^ component ifNil: [ component := self buildComponent ]! !

!PRPaypalStoreView methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 20:19'!
editItem
! !

!PRPaypalStoreView methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 20:20'!
removeItem! !

!PRPaypalStoreView methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 23:31'!
renderContentOn: html
	super renderContentOn: html.
	self renderStoreOn: html.

! !

!PRPaypalStoreView methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 23:33'!
renderStoreOn: html
	html render: self report
	! !

!PRPaypalStoreView methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 23:33'!
renderViewerOn: html
	html render: self component

! !

!PRPaypalStoreView methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 20:13'!
report
	^ report ifNil: [ report := self buildReport ]! !

!PRPaypalStoreView methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 23:47'!
store
	^store ifNil: [ store := self find: PRPaypalStore ]! !

MAActionColumn subclass: #PRPaypalCommandColumn
	instanceVariableNames: 'item store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Seaside'!

PRPaypalCommandColumn subclass: #PRPaypalAddToCartCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Paypal-Seaside'!

!PRPaypalAddToCartCommand methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 18:57'!
initialize
	super initialize.
	self cmd: '_xclick'! !

!PRPaypalAddToCartCommand methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 19:00'!
renderCellFormContentOn: html
	html hiddenInput
		name: 'cmd';
		value: '_xclick'.
	super renderCellFormContentOn: html! !

!PRPaypalCommandColumn class methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 10:26'!
descriptionCmd
	^MASingleOptionDescription new
		options: #( '_cart' '_xclick' '_donations' '_oe-gift-certificate' '_xclick-subscriptions');
		propertyAccessor: #cmd;
		comment: 'Cmd input value for the item';
		priority: 10;
		yourself! !

!PRPaypalCommandColumn class methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 18:03'!
forItem: anItem inStore: aStore
	^self new 
		store: aStore; 
		item: anItem; 
		yourself! !

!PRPaypalCommandColumn methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 18:25'!
altText
	^self subclassResponsibility! !

!PRPaypalCommandColumn methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 10:23'!
cmd
	^self propertyAt: 'cmd' ifAbsent: [^nil]! !

!PRPaypalCommandColumn methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 18:57'!
cmd: aCommand
	^self propertyAt: 'cmd' put: aCommand! !

!PRPaypalCommandColumn methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 09:07'!
defaultUseLinks
	^false! !

!PRPaypalCommandColumn methodsFor: 'as yet unclassified' stamp: 'jmck 3/14/2009 18:25'!
imageUrl
	^self subclassResponsibility! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/14/2009 19:17'!
item
	"Answer the value of item"

	^ item! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/14/2009 19:34'!
item: anObject
	"Set the value of item"

	item := anObject! !

!PRPaypalCommandColumn methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 00:14'!
renderCellFormContentOn: html
	html form: [
		self store properties keysAndValuesDo: [ :each :desc | 
			desc isSetting ifTrue: [ self renderSetting: each with: desc on: html] ].
		self item properties keysAndValuesDo: [ :each :desc | 
			desc isSetting ifTrue: [ self renderSetting: each with: desc on: html] ].
		html imageButton 
			name: 'submit';
			url: self imageUrl;
			attributeAt: 'alt' put: self altText ]
		
	! !

!PRPaypalCommandColumn methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:05'!
renderItemSetting: aSetting for: aDescription on: html
	html hiddenInput
		name: aSetting;
		value: (aDescription toString: (self item propertyAt: aSetting)).
! !

!PRPaypalCommandColumn methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 00:15'!
renderSetting: aSetting for: aDescription on: html
	html hiddenInput
		name: aSetting;
		value: (aDescription toString: (self item readUsing: aDescription)).
! !

!PRPaypalCommandColumn methodsFor: 'as yet unclassified' stamp: 'jmck 3/15/2009 01:05'!
renderStoreSetting: aSetting for: aDescription on: html
	html hiddenInput
		name: aSetting;
		value: (aDescription toString: (self store propertyAt: aSetting)).
! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/14/2009 19:17'!
store
	"Answer the value of store"

	^ store! !

!PRPaypalCommandColumn methodsFor: 'accessing' stamp: 'jmck 3/14/2009 19:18'!
store: anObject
	"Set the value of store"

	store := anObject! !
